## cpu-x 4.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
cmake_policy(SET CMP0048 NEW)
if(POLICY CMP0075)
	cmake_policy(SET CMP0075 NEW)
endif()
project(cpu-x
	VERSION "4.5.1"
	LANGUAGES C
)


### DEFAULT CONFIG

# Global variables
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(GNUInstallDirs)
if(NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
	set(CMAKE_INSTALL_LIBEXECDIR      lib/${CMAKE_PROJECT_NAME})
	set(CMAKE_INSTALL_FULL_LIBEXECDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR})
endif(NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/bin/)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/lib/)
set(CMAKE_DATA_OUTPUT_DIRECTORY    ${CMAKE_BINARY_DIR}/output/data/)
set(CPU_X_DATA_DIRECTORY           ${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}/)
set(APP_EXEC                       ${CMAKE_PROJECT_NAME})
set(DAEMON_EXEC                    ${CMAKE_PROJECT_NAME}-daemon)
set(DAEMON_PATH                    ${CMAKE_INSTALL_FULL_LIBEXECDIR}/${DAEMON_EXEC})
if(CMAKE_SIZEOF_VOID_P EQUAL 4)
	set(BITNESS "32")
else(CMAKE_SIZEOF_VOID_P EQUAL 4)
	set(BITNESS "64")
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-deprecated-declarations -Wno-unused-result")
set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wstrict-prototypes -Wformat -Wformat-security")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")

include(CheckCCompilerFlag)
check_c_compiler_flag("-no-pie" HAS_NO_PIE)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND HAS_NO_PIE)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -no-pie")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND HAS_NO_PIE)

# Options
option(WITH_GTK           "Build support for GUI in GTK3+"                                    ON)
option(WITH_NCURSES       "Build support for TUI in NCurses"                                  ON)
option(WITH_GETTEXT       "Build support for internationalization"                            ON)
option(WITH_LIBCPUID      "Use Libcpuid library"                                              ON)
option(WITH_LIBPCI        "Use Libpci library"                                                ON)
option(WITH_LIBGLFW       "Use Libglfw library"                                               ON)
option(WITH_VULKAN        "Use Vulkan library"                                                ON)
option(WITH_OPENCL        "Use OpenCL library"                                                ON)
option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
option(WITH_BANDWIDTH     "Built-in Bandwidth"                                                ON)
option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)

# Colours
string(ASCII 27 Esc)
set(ColourReset "${Esc}[m")
set(ColourBold  "${Esc}[1m")
set(Red         "${Esc}[31m")
set(Green       "${Esc}[32m")
set(Yellow      "${Esc}[33m")
set(Blue        "${Esc}[34m")
set(Magenta     "${Esc}[35m")
set(Cyan        "${Esc}[36m")
set(White       "${Esc}[37m")
set(BoldRed     "${Esc}[1;31m")
set(BoldGreen   "${Esc}[1;32m")
set(BoldYellow  "${Esc}[1;33m")
set(BoldBlue    "${Esc}[1;34m")
set(BoldMagenta "${Esc}[1;35m")
set(BoldCyan    "${Esc}[1;36m")
set(BoldWhite   "${Esc}[1;37m")


### MACROS

# Macro: print_config(libname foundstate withstate)
# Print the state of CPU-X features: in bold green if enabled, else bold red.
# @libname:    library name (e.g. GTK)
# @libver:     library version (e.g. XXXXX_VERSION)
# @foundstate: the result of pkg_check_modules(...) (e.g. XXXXX_FOUND)
# @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
macro(print_config libname libver foundstate withstate)
	if(${foundstate} AND ${withstate})
		message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset}")
		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
	else(${foundstate} AND ${withstate})
		if(NOT ${withstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (explicitly disabled)")
		elseif(NOT ${foundstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (not found by pkg-config)")
		endif()
		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
	endif(${foundstate} AND ${withstate})
endmacro(print_config)


### HELPERS / SUBDIRECTORIES

set(GIT_REVISION "")
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
	find_package(Git)
	if(GIT_FOUND)
		execute_process(COMMAND sh -c "${GIT_EXECUTABLE} describe --long --tags --exclude continuous --abbrev=40 --dirty | cut --delimiter=- --fields=2-"
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			OUTPUT_VARIABLE GIT_DESCRIBE_REVISION
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
		if(NOT ${GIT_DESCRIBE_REVISION} STREQUAL "")
			set(GIT_REVISION "+git-r${GIT_DESCRIBE_REVISION}")
		endif(NOT ${GIT_DESCRIBE_REVISION} STREQUAL "")
	endif(GIT_FOUND)
endif(EXISTS ${CMAKE_SOURCE_DIR}/.git)

enable_testing()
find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)
find_package(Backtrace REQUIRED)
if(WITH_GETTEXT)
	find_package(Gettext)
	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
		find_package(Intl)
	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
endif(WITH_GETTEXT)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckIncludeFile)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)


### UNINSTALL TARGET

configure_file("${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== src/CMakeLists.txt ===
### FIND NEEDED LIBRAIRIES

# GTK3+
if(WITH_GTK)
	set(MINIMUM_GTK_VERSION 3.12.0)
	pkg_check_modules(GTK3 gtk+-3.0>=${MINIMUM_GTK_VERSION})
	if(GTK3_FOUND)
		include_directories(${GTK3_INCLUDE_DIRS})
		link_directories(${GTK3_LIBRARY_DIRS})
		add_definitions(${GTK3_CFLAGS_OTHER})
		add_library(gui_gtk STATIC
			gui_gtk.c
			gui_gtk.h
			gui_gtk_id.h
			${GRESOURCES}
		)
		set(GTK3_LIBRARIES "gui_gtk" ${GTK3_LIBRARIES})
	else(GTK3_FOUND)
		message("${BoldYellow}GTK3+ GUI will not be build:${ColourReset} ${Yellow}GTK ${MINIMUM_GTK_VERSION} or higher is needed.${ColourReset}")
		message("${Yellow}Set ${BoldYellow}PKG_CONFIG_PATH${ColourReset}${Yellow} environment variable if development files are installed.${ColourReset}")
	endif(GTK3_FOUND)
endif(WITH_GTK)

# NCurses
if(WITH_NCURSES)
	pkg_check_modules(NCURSES ncursesw)
	if(NCURSES_FOUND)
		include_directories(${NCURSES_INCLUDE_DIRS})
		link_directories(${NCURSES_LIBRARY_DIRS})
		add_library(tui_ncurses STATIC
			tui_ncurses.c
			tui_ncurses.h
		)
		set(NCURSES_LIBRARIES "tui_ncurses" ${NCURSES_LIBRARIES})
	endif(NCURSES_FOUND)
endif(WITH_NCURSES)

# Gettext
if(Intl_FOUND)
	include_directories(${CMAKE_BINARY_DIR}/po)
endif(Intl_FOUND)

# Libcpuid
if(WITH_LIBCPUID)
	pkg_check_modules(LIBCPUID libcpuid>=0.6.0)
	if(LIBCPUID_FOUND)
		include_directories(${LIBCPUID_INCLUDE_DIRS})
		link_directories(${LIBCPUID_LIBRARY_DIRS})
		add_definitions(${LIBCPUID_CFLAGS_OTHER})
		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
	endif(LIBCPUID_FOUND)
endif(WITH_LIBCPUID)

# Libpci
if(WITH_LIBPCI)
	pkg_check_modules(LIBPCI libpci)
	if(LIBPCI_FOUND)
		include_directories(${LIBPCI_INCLUDE_DIRS})
		link_directories(${LIBPCI_LIBRARY_DIRS})
		add_definitions(${LIBPCI_CFLAGS_OTHER})
	endif(LIBPCI_FOUND)
endif(WITH_LIBPCI)

# Libglfw
if(WITH_LIBGLFW)
	pkg_check_modules(LIBGL gl)
	pkg_check_modules(LIBGLFW glfw3>=3.3)
	if(LIBGL_FOUND AND LIBGLFW_FOUND)
		include_directories(${LIBGL_INCLUDE_DIRS} ${LIBGLFW_INCLUDE_DIRS})
		link_directories(${LIBGL_LIBRARY_DIRS} ${LIBGLFW_LIBRARY_DIRS})
		add_definitions(${LIBGL_CFLAGS_OTHER} ${LIBGLFW_CFLAGS_OTHER})
	endif(LIBGL_FOUND AND LIBGLFW_FOUND)

endif(WITH_LIBGLFW)

# Vulkan
if(WITH_VULKAN)
	pkg_check_modules(VULKAN vulkan)
	if(VULKAN_FOUND)
		include_directories(${VULKAN_INCLUDE_DIRS})
		link_directories(${VULKAN_LIBRARY_DIRS})
		add_definitions(${VULKAN_CFLAGS_OTHER})
	endif(VULKAN_FOUND)
endif(WITH_VULKAN)

# OpenCL
if(WITH_OPENCL)
	pkg_check_modules(OPENCL OpenCL)
	if(OPENCL_FOUND)
		include_directories(${LIBOPENCL_INCLUDE_DIRS} ${OpenCL_INCLUDE_DIRS})
		link_directories(${LIBOPENCL_LIBRARY_DIRS} ${OpenCL_LIBRARY_DIRS})
		add_definitions(${LIBOPENCL_CFLAGS_OTHER} ${OpenCL_CFLAGS_OTHER})
	endif(OPENCL_FOUND)
endif(WITH_OPENCL)

# Libprocps
set(LIBSYSTEM 0)
set(LIBPROC2 -1)
if(WITH_LIBPROCPS AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	pkg_check_modules(LIBPROC2 libproc-2)
	if(LIBPROC2_FOUND)
		include_directories(${LIBPROC2_INCLUDE_DIRS})
		link_directories(${LIBPROC2_LIBRARY_DIRS})
		add_definitions(${LIBPROC2_CFLAGS_OTHER})
		set(LIBSYSTEM 1)
		set(LIBPROC2 1)
	else()
		pkg_check_modules(LIBPROCPS libprocps)
		set(LIBPROC2 0)
	endif()
	if(LIBPROCPS_FOUND)
		include_directories(${LIBPROCPS_INCLUDE_DIRS})
		link_directories(${LIBPROCPS_LIBRARY_DIRS})
		add_definitions(${LIBPROCPS_CFLAGS_OTHER})
		set(LIBSYSTEM 1)
	endif(LIBPROCPS_FOUND)
endif(WITH_LIBPROCPS AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)

# Libstatgrab
if(WITH_LIBSTATGRAB AND (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR FORCE_LIBSTATGRAB))
	pkg_check_modules(LIBSTATGRAB libstatgrab)
	if(LIBSTATGRAB_FOUND)
		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
		add_definitions(${LIBSTATGRAB_CFLAGS_OTHER})
		set(LIBSYSTEM 2)
	endif(LIBSTATGRAB_FOUND)
endif(WITH_LIBSTATGRAB AND (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR FORCE_LIBSTATGRAB))

# Dmidecode
if(WITH_DMIDECODE)
	add_subdirectory(dmidecode)
	include_directories(dmidecode)
	set(DMIDECODE_LIBRARIES "dmidecode")
endif(WITH_DMIDECODE)

# Bandwidth
if(WITH_BANDWIDTH)
	add_subdirectory(bandwidth)
	if(BANDWIDTH_FOUND)
		include_directories(bandwidth)
		set(BANDWIDTH_LIBRARIES "bandwidth")
	endif(BANDWIDTH_FOUND)
endif(WITH_BANDWIDTH)


### FINAL CONFIG

message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration **${ColourReset}")

# UI libraries
print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
print_config("NCURSES"             "${NCURSES_VERSION}"     NCURSES_FOUND     WITH_NCURSES)

# Other libraries
print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
print_config("LIBGLFW"             "${LIBGLFW_VERSION}"     LIBGLFW_FOUND     WITH_LIBGLFW)
print_config("Vulkan"              "${VULKAN_VERSION}"      VULKAN_FOUND      WITH_VULKAN)
print_config("OpenCL"              "${OPENCL_VERSION}"      OPENCL_FOUND      WITH_OPENCL)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	if(${LIBPROC2} EQUAL 1)
		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"    LIBPROC2_FOUND    WITH_LIBPROCPS)
	else()
		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"   LIBPROCPS_FOUND   WITH_LIBPROCPS)
	endif()
else()
	print_config("LIBSTATGRAB" "${LIBSTATGRAB_VERSION}" LIBSTATGRAB_FOUND WITH_LIBSTATGRAB)
endif()

# Subprojects
print_config("DMIDECODE"           "${DMIDECODE_VERSION}"   1                 WITH_DMIDECODE)
print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"   BANDWIDTH_FOUND   WITH_BANDWIDTH)


### MAIN BINARY

# Executable
add_executable(${APP_EXEC}
	main.c
	util.c
	cpu-x.h
	core.c
	core.h
	ipc.h
)

add_executable(${DAEMON_EXEC}
	daemon.c
	daemon.h
	ipc.h
	cpu-x.h
)

# Libsystem extra-definitions
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 1) # When Libprocps is used
	add_definitions(-DHAS_LIBSTATGRAB=0 -DLIBSTATGRAB_VERSION=NULL)
	if(${LIBPROC2} EQUAL 1)
		add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
	else(${LIBPROC2} EQUAL 0)
		add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	endif()
endif()
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 2) # When Libstatgrab is used
	add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
endif()

# Various definitions
add_definitions(-DPRGVER="${PROJECT_VERSION}"
	-DGITREV="${GIT_REVISION}"
	-DSYSTEM_NAME="${CMAKE_SYSTEM_NAME}"
	-DSYSTEM_PROCESSOR="${CMAKE_SYSTEM_PROCESSOR}"
	-DC_COMPILER_ID="${CMAKE_C_COMPILER_ID}"
	-DHAS_LIBSYSTEM=${LIBSYSTEM}
	-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}"
	-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
	-DTERMINFODIR="/lib/terminfo"
	-DDAEMON_EXEC="${DAEMON_EXEC}"
	-DDAEMON_PATH="${DAEMON_PATH}"
)

if(APPIMAGE)
	set(DAEMON_FLAGS "-static")
	set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
endif(APPIMAGE)

# Link libraries
target_link_libraries(${APP_EXEC}
	m
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	${Backtrace_LIBRARIES}

	${GTK3_LIBRARIES}
	${NCURSES_LIBRARIES}
	${LIBCPUID_LIBRARIES}
	${LIBPCI_LIBRARIES}
	${LIBGL_LIBRARIES}
	${LIBGLFW_LIBRARIES}
	${VULKAN_LIBRARIES}
	${OPENCL_LIBRARIES}
	${LIBPROC2_LIBRARIES}
	${LIBPROCPS_LIBRARIES}
	${LIBSTATGRAB_LIBRARIES}
	${DMIDECODE_LIBRARIES}
	${BANDWIDTH_LIBRARIES}
	${OTHER_LIBRARIES}
)

target_link_libraries(${DAEMON_EXEC}
	${DAEMON_FLAGS}
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}

	${LIBCPUID_LIBRARIES}
	${DMIDECODE_LIBRARIES}
)


### INSTALLATION
install(TARGETS ${APP_EXEC}    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}/)
install(TARGETS ${DAEMON_EXEC} DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}/)

=== debian/changelog ===
cpu-x (4.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 26 Oct 2022 21:55:18 +0200

cpu-x (4.5.0-1) unstable; urgency=medium

  * New upstream release.
    - (This rebuilds the package against current libcpi). (Closes: #1020740).
  * debian/control:
    + Update Martin's mail address in Maintainer: field. (Closes: #1014137).
    + Bump versioned B-D on libcpuid to (>= 0.6.0).
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/patches:
    + Add 1001_typo-fix.patch
    + Mark 200*_*.patch files as Debian-specific.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 21 Oct 2022 10:01:16 +0200

=== debian/control ===
Source: cpu-x
Section: x11
Priority: optional
Maintainer: Martin Wimpress <code@wimpress.io>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3),
               gawk,
               gettext,
               libcpuid-dev (>= 0.6.0) [amd64 i386],
               libgtk-3-dev (>= 3.12),
               libcurl4-gnutls-dev,
               libglfw3-dev,
               libjson-c-dev,
               libncurses-dev,
               libpci-dev,
               libprocps-dev,
               libstatgrab-dev,
               nasm,
               pkg-config,
               procps,
Standards-Version: 4.6.1
Homepage: https://github.com/X0rg/CPU-X
Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
Vcs-Browser: https://salsa.debian.org/debian/cpu-x
Rules-Requires-Root: no

Package: cpu-x
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
Description: Tool that gathers information on CPU, motherboard and more
 CPU-X is similar to CPU-Z (for MS Windows). It can be used in graphical
 mode by using GTK or in text-based mode by using NCurses. A dump mode is
 present from the command line.

## cpu-x 4.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	cmake_policy(SET CMP0075 NEW)
 endif()
 project(cpu-x
-	VERSION "4.5.1"
+	VERSION "4.5.2"
 	LANGUAGES C
 )

=== po/CMakeLists.txt ===
project(po
	LANGUAGES NONE
)


### INTERNATIONALIZATION TARGETS

# PO files
set(pot_file ${CMAKE_PROJECT_NAME}.pot)
file(GLOB
	po_files
	*.po
)

if(GETTEXT_FOUND)
	set(GETTEXT_FOUND ON PARENT_SCOPE)
	include(gettext_create_translations)
	add_custom_target(genpot
		COMMAND xgettext
			--language=C
			--keyword=_ --keyword=N_ --indent
			--add-comments=TRANSLATORS:
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/TheTumultuousUnicornOfDarkness/CPU-X/issues
			--copyright-holder=TheTumultuousUnicornOfDarkness
			--output-dir=${CMAKE_CURRENT_BINARY_DIR}
			--output=source_c.pot
			--directory="../src"
			--from-code="utf-8"
			"*.c" "cpu-x.h"
		COMMAND xgettext
			--language=Glade
			--keyword=translatable --indent
			--add-comments
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/TheTumultuousUnicornOfDarkness/CPU-X/issues
			--copyright-holder=TheTumultuousUnicornOfDarkness
			--output-dir=${CMAKE_CURRENT_BINARY_DIR}
			--output=source_ui.pot
			--directory="../data"
			--from-code="utf-8"
			"cpu-x-gtk-3.12.ui"
		COMMAND	msgcat --indent --directory=${CMAKE_CURRENT_BINARY_DIR} source_c.pot source_ui.pot --output-file="${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		COMMAND sed --in-place "s/SOME DESCRIPTIVE TITLE./CPU-X translations template/" "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2022/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
	)
	GETTEXT_CONVERT_TRANSLATIONS(${pot_file} ALL ${po_files})
else(GETTEXT_FOUND)
	set(GETTEXT_FOUND OFF PARENT_SCOPE)
endif(GETTEXT_FOUND)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -97,7 +97,7 @@
 set(LIBSYSTEM 0)
 set(LIBPROC2 -1)
 if(WITH_LIBPROCPS AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
-	pkg_check_modules(LIBPROC2 libproc-2)
+	pkg_check_modules(LIBPROC2 libproc2)
 	if(LIBPROC2_FOUND)
 		include_directories(${LIBPROC2_INCLUDE_DIRS})
 		link_directories(${LIBPROC2_LIBRARY_DIRS})
@@ -223,7 +223,12 @@
 
 if(APPIMAGE)
 	set(DAEMON_FLAGS "-static")
-	set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
+	if(LIBCPUID_FOUND)
+		set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
+	endif(LIBCPUID_FOUND)
+	if(VULKAN_FOUND)
+		add_definitions(-DVK_INSTANCE_CREATE_ENUMERATE_PORTABILITY_BIT_KHR=1)
+	endif(VULKAN_FOUND)
 endif(APPIMAGE)
 
 # Link libraries

=== debian/changelog ===
cpu-x (4.5.2-2) unstable; urgency=medium

  * debian/control:
    + In B-D, switch from libprocps-dev to libproc2-dev.
    + Add B-D: libvulkan-dev. This enables 'Vulkan' support in cpu-x.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2023 08:43:22 +0100

cpu-x (4.5.2-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/control:
    + Bump versioned B-D on libcpuid-dev to (>= 0.6.2).
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 29 Jan 2023 14:02:07 +0100

=== debian/control ===
--- 
+++ 
@@ -8,19 +8,20 @@
                cmake (>= 3),
                gawk,
                gettext,
-               libcpuid-dev (>= 0.6.0) [amd64 i386],
+               libcpuid-dev (>= 0.6.2) [amd64 i386],
                libgtk-3-dev (>= 3.12),
                libcurl4-gnutls-dev,
                libglfw3-dev,
                libjson-c-dev,
                libncurses-dev,
                libpci-dev,
-               libprocps-dev,
+               libproc2-dev,
                libstatgrab-dev,
+               libvulkan-dev,
                nasm,
                pkg-config,
                procps,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/X0rg/CPU-X
 Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
 Vcs-Browser: https://salsa.debian.org/debian/cpu-x

## cpu-x 4.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	cmake_policy(SET CMP0075 NEW)
 endif()
 project(cpu-x
-	VERSION "4.5.2"
+	VERSION "4.5.3"
 	LANGUAGES C
 )
 
@@ -49,7 +49,7 @@
 option(WITH_LIBPCI        "Use Libpci library"                                                ON)
 option(WITH_LIBGLFW       "Use Libglfw library"                                               ON)
 option(WITH_VULKAN        "Use Vulkan library"                                                ON)
-option(WITH_OPENCL        "Use OpenCL library"                                                ON)
+option(WITH_OPENCL        "Use OpenCL library"                                                OFF) # Disabled due to issues (#238, #258, #264)
 option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
 option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
 option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)

=== debian/changelog ===
cpu-x (4.5.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_typo-fix.patch. Applied upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 20 Jun 2023 13:24:53 +0200

## cpu-x 5.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,18 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.12)
 cmake_policy(SET CMP0048 NEW)
 if(POLICY CMP0075)
 	cmake_policy(SET CMP0075 NEW)
 endif()
 project(cpu-x
-	VERSION "4.5.3"
-	LANGUAGES C
+	VERSION "5.0.3"
+	LANGUAGES C CXX
 )
 
 
 ### DEFAULT CONFIG
 
 # Global variables
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 include(GNUInstallDirs)
 if(NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
@@ -25,13 +26,21 @@
 set(APP_EXEC                       ${CMAKE_PROJECT_NAME})
 set(DAEMON_EXEC                    ${CMAKE_PROJECT_NAME}-daemon)
 set(DAEMON_PATH                    ${CMAKE_INSTALL_FULL_LIBEXECDIR}/${DAEMON_EXEC})
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+	set(DAEMON_SOCKET              "/run/cpu-x.sock")
+else()
+	set(DAEMON_SOCKET              "/var/run/cpu-x.sock")
+endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 if(CMAKE_SIZEOF_VOID_P EQUAL 4)
 	set(BITNESS "32")
 else(CMAKE_SIZEOF_VOID_P EQUAL 4)
 	set(BITNESS "64")
 endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
+set(CMAKE_COLOR_DIAGNOSTICS ON)
 set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-deprecated-declarations -Wno-unused-result")
-set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wstrict-prototypes -Wformat -Wformat-security")
+set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} -Wpedantic -Wno-deprecated-declarations -Wno-unused-result")
+set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security -Wstrict-prototypes")
+set(CMAKE_CXX_FLAGS_DEBUG     "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
 set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
 
@@ -55,7 +64,7 @@
 option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
 option(WITH_BANDWIDTH     "Built-in Bandwidth"                                                ON)
 option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
-option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
+option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)
 
 # Colours
 string(ASCII 27 Esc)
@@ -122,6 +131,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads REQUIRED)
 find_package(Backtrace REQUIRED)
+find_package(Filesystem REQUIRED)
 if(WITH_GETTEXT)
 	find_package(Gettext)
 	if(${CMAKE_VERSION} VERSION_GREATER "3.1")

=== data/CMakeLists.txt ===
project(data
	LANGUAGES NONE
)


add_subdirectory(completions)

# Files needed by GTK GUI
if(WITH_GTK)
	include(GSettings)

	# Set config
	file(MAKE_DIRECTORY ${CMAKE_DATA_OUTPUT_DIRECTORY})
	configure_file(io.github.thetumultuousunicornofdarkness.cpu-x.desktop.in       ${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop)
	configure_file(io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy.in ${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy)

	# Install UIs
	install(FILES
		cpu-x-gtk-3.12.ui
		cpu-x-gtk-3.12.css
		cpu-x-gtk-3.12-dark.css
		cpu-x-gtk-3.20.css
		cpu-x-gtk-3.20-dark.css
		DESTINATION ${CPU_X_DATA_DIRECTORY}/
	)

	# AppData metainfo file
	install(FILES
		io.github.thetumultuousunicornofdarkness.cpu-x.appdata.xml
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo/
	)

	# Install launcher
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications/
	)

	# Install policy rule
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/
	)

	# Install schema file
	add_schema("io.github.thetumultuousunicornofdarkness.cpu-x.gschema.xml")

	add_subdirectory(icons)
	add_subdirectory(logos)
endif(WITH_GTK)

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	include(gettext_create_translations)
 	add_custom_target(genpot
 		COMMAND xgettext
-			--language=C
+			--language=C++
 			--keyword=_ --keyword=N_ --indent
 			--add-comments=TRANSLATORS:
 			--package-name=${CMAKE_PROJECT_NAME}
@@ -29,7 +29,7 @@
 			--output=source_c.pot
 			--directory="../src"
 			--from-code="utf-8"
-			"*.c" "cpu-x.h"
+			"*.cpp" "data.hpp" "util.hpp"
 		COMMAND xgettext
 			--language=Glade
 			--keyword=translatable --indent
@@ -46,7 +46,7 @@
 			"cpu-x-gtk-3.12.ui"
 		COMMAND	msgcat --indent --directory=${CMAKE_CURRENT_BINARY_DIR} source_c.pot source_ui.pot --output-file="${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
 		COMMAND sed --in-place "s/SOME DESCRIPTIVE TITLE./CPU-X translations template/" "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
-		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2022/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
+		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2024/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
 		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
 	)
 	GETTEXT_CONVERT_TRANSLATIONS(${pot_file} ALL ${po_files})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,15 +3,14 @@
 # GTK3+
 if(WITH_GTK)
 	set(MINIMUM_GTK_VERSION 3.12.0)
-	pkg_check_modules(GTK3 gtk+-3.0>=${MINIMUM_GTK_VERSION})
+	pkg_check_modules(GTK3 gtkmm-3.0>=${MINIMUM_GTK_VERSION})
 	if(GTK3_FOUND)
 		include_directories(${GTK3_INCLUDE_DIRS})
 		link_directories(${GTK3_LIBRARY_DIRS})
 		add_definitions(${GTK3_CFLAGS_OTHER})
 		add_library(gui_gtk STATIC
-			gui_gtk.c
-			gui_gtk.h
-			gui_gtk_id.h
+			gui_gtk.cpp
+			gui_gtk.hpp
 			${GRESOURCES}
 		)
 		set(GTK3_LIBRARIES "gui_gtk" ${GTK3_LIBRARIES})
@@ -23,13 +22,19 @@
 
 # NCurses
 if(WITH_NCURSES)
-	pkg_check_modules(NCURSES ncursesw)
+	# Assume ncurses from the base on FreeBSD
+	if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+		set(NCURSES_FOUND 1)
+		set(NCURSES_LIBRARIES "-l:libncursesw.so")
+	else()
+		pkg_check_modules(NCURSES ncursesw)
+	endif()
 	if(NCURSES_FOUND)
 		include_directories(${NCURSES_INCLUDE_DIRS})
 		link_directories(${NCURSES_LIBRARY_DIRS})
 		add_library(tui_ncurses STATIC
-			tui_ncurses.c
-			tui_ncurses.h
+			tui_ncurses.cpp
+			tui_ncurses.hpp
 		)
 		set(NCURSES_LIBRARIES "tui_ncurses" ${NCURSES_LIBRARIES})
 	endif(NCURSES_FOUND)
@@ -37,7 +42,7 @@
 
 # Gettext
 if(Intl_FOUND)
-	include_directories(${CMAKE_BINARY_DIR}/po)
+	include_directories(${Intl_INCLUDE_DIRS})
 endif(Intl_FOUND)
 
 # Libcpuid
@@ -178,19 +183,32 @@
 
 # Executable
 add_executable(${APP_EXEC}
-	main.c
-	util.c
-	cpu-x.h
-	core.c
-	core.h
-	ipc.h
+	core.cpp
+	core.hpp
+	daemon_client.cpp
+	daemon_client.hpp
+	daemon.h
+	data.cpp
+	data.hpp
+	logger.cpp
+	logger.hpp
+	main.cpp
+	options.cpp
+	options.hpp
+	util.cpp
+	util.hpp
 )
 
 add_executable(${DAEMON_EXEC}
-	daemon.c
+	daemon_server.cpp
+	daemon_server.hpp
 	daemon.h
-	ipc.h
-	cpu-x.h
+	logger.cpp
+	logger.hpp
+	options.cpp
+	options.hpp
+	util.cpp
+	util.hpp
 )
 
 # Libsystem extra-definitions
@@ -206,6 +224,16 @@
 	add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
 	add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
 endif()
+
+# Flatpak workarounds
+if(FLATPAK)
+	add_definitions(-DFLATPAK)
+	set(DAEMON_SOCKET cpu-x.sock)
+	if(LIBCPUID_FOUND)
+		# flatpak-spawn command will not be able to find libcpuid.so when starting cpu-x-daemon
+		set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
+	endif(LIBCPUID_FOUND)
+endif(FLATPAK)
 
 # Various definitions
 add_definitions(-DPRGVER="${PROJECT_VERSION}"
@@ -218,25 +246,17 @@
 	-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
 	-DTERMINFODIR="/lib/terminfo"
 	-DDAEMON_EXEC="${DAEMON_EXEC}"
+	-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
 	-DDAEMON_PATH="${DAEMON_PATH}"
-)
-
-if(APPIMAGE)
-	set(DAEMON_FLAGS "-static")
-	if(LIBCPUID_FOUND)
-		set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
-	endif(LIBCPUID_FOUND)
-	if(VULKAN_FOUND)
-		add_definitions(-DVK_INSTANCE_CREATE_ENUMERATE_PORTABILITY_BIT_KHR=1)
-	endif(VULKAN_FOUND)
-endif(APPIMAGE)
+	-DSOCKET_NAME="${DAEMON_SOCKET}"
+)
 
 # Link libraries
 target_link_libraries(${APP_EXEC}
-	m
 	${Intl_LIBRARIES}
 	${CMAKE_THREAD_LIBS_INIT}
 	${Backtrace_LIBRARIES}
+	std::filesystem
 
 	${GTK3_LIBRARIES}
 	${NCURSES_LIBRARIES}
@@ -258,6 +278,7 @@
 	${DAEMON_FLAGS}
 	${Intl_LIBRARIES}
 	${CMAKE_THREAD_LIBS_INIT}
+	std::filesystem
 
 	${LIBCPUID_LIBRARIES}
 	${DMIDECODE_LIBRARIES}

=== tests/CMakeLists.txt ===
project(tests
	LANGUAGES NONE
)

add_test(NAME test_awk_regex  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/awk/test_regex.sh")
add_test(NAME test_grep_regex COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/grep/test_regex.sh")

=== src/dmidecode/CMakeLists.txt ===
project(dmidecode
	VERSION "3.5.20230314"
	LANGUAGES C
)

# Config (dmidecode)
set(CMAKE_C_FLAGS       "${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-shift-count-overflow")
message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")

# Build (dmidecode)
add_definitions(-DVERSION="${PROJECT_VERSION}")
add_library(dmidecode
	STATIC
	types.h
	util.c
	util.h
	dmiopt.h
	dmiopt.c
	dmioem.c
	dmioem.h
	dmidecode.c
	dmidecode.h
	dmioutput.c
	dmioutput.h
)

target_link_libraries(dmidecode)
set(DMIDECODE_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

=== debian/changelog ===
cpu-x (5.0.3-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:41:44 +1100

cpu-x (5.0.3-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:08:42 +0000

cpu-x (5.0.3-2) unstable; urgency=medium

  * debian/control:
    + Use libgtkmm-3.0-dev instead of libgtk-3-dev in B-D. This brings back the
      GTK-Gui that got lost in by previous upload.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 12 Feb 2024 17:37:48 +0100

cpu-x (5.0.3-1) unstable; urgency=medium

  * New upstream release
  * debian/patches:
    + Trivially rebase 2001_build-with-PIE.patch.
  * debian/control:
    + Enforce using latest libcpuid (i.e. >= 0.6.4).
  * debian/man/cpu-x_polkit.1:
    + Drop symlink to actual man page. Not used anymore.
  * debian/man/cpu-x.1:
    + Rework man page. (Closes: #1034355, #1034357).
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Rework entire file and update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 09 Feb 2024 10:23:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: cpu-x
 Section: x11
 Priority: optional
-Maintainer: Martin Wimpress <code@wimpress.io>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Martin Wimpress <code@wimpress.io>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                cmake (>= 3),
                gawk,
                gettext,
-               libcpuid-dev (>= 0.6.2) [amd64 i386],
-               libgtk-3-dev (>= 3.12),
+               libcpuid-dev (>= 0.6.4) [amd64 i386],
+               libgtkmm-3.0-dev (>= 3.12),
                libcurl4-gnutls-dev,
                libglfw3-dev,
                libjson-c-dev,

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/cpu-x-$1.tar.gz/ \
https://github.com/X0rg/CPU-X/tags .*/archive/refs/tags/v?([\d\.]+).tar.gz

## cpu-x 5.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	cmake_policy(SET CMP0075 NEW)
 endif()
 project(cpu-x
-	VERSION "5.0.3"
+	VERSION "5.0.4"
 	LANGUAGES C CXX
 )
 
@@ -140,6 +140,7 @@
 endif(WITH_GETTEXT)
 include(CheckSymbolExists)
 include(CheckStructHasMember)
+include(CheckCSourceCompiles)
 include(CheckIncludeFile)
 add_subdirectory(data)
 add_subdirectory(po)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,22 @@
 		link_directories(${LIBCPUID_LIBRARY_DIRS})
 		add_definitions(${LIBCPUID_CFLAGS_OTHER})
 		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
+		check_c_source_compiles(
+			"
+			#include <stdio.h>
+			#include <libcpuid/libcpuid.h>
+
+			int main()
+			{
+				printf(\"%i\", PURPOSE_LP_EFFICIENCY);
+				return 0;
+			}
+			"
+			HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY
+		)
+		if(HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
+			add_definitions(-DHAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
+		endif(HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
 	endif(LIBCPUID_FOUND)
 endif(WITH_LIBCPUID)

=== src/dmidecode/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(dmidecode
-	VERSION "3.5.20230314"
+	VERSION "3.6.20240424"
 	LANGUAGES C
 )

=== debian/changelog ===
cpu-x (5.0.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 14 Jun 2024 08:34:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: cpu-x
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Martin Wimpress <code@wimpress.io>
+Maintainer: Martin Wimpress <code@wimpress.io>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -22,7 +21,7 @@
                nasm,
                pkg-config,
                procps,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/X0rg/CPU-X
 Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
 Vcs-Browser: https://salsa.debian.org/debian/cpu-x

## cpu-x 5.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 cmake_minimum_required(VERSION 3.12)
-cmake_policy(SET CMP0048 NEW)
-if(POLICY CMP0075)
-	cmake_policy(SET CMP0075 NEW)
+# https://cmake.org/cmake/help/latest/policy/CMP0177.html
+if(POLICY CMP0177)
+	cmake_policy(SET CMP0177 NEW)
 endif()
 project(cpu-x
-	VERSION "5.0.4"
+	VERSION "5.1.1"
 	LANGUAGES C CXX
 )
 
@@ -15,10 +15,12 @@
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 include(GNUInstallDirs)
-if(NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
+# Avoid to put files under /usr/libexec or /usr/local/libexec on Linux when the path does not exist
+# On FreeBSD, /usr/local/libexec is missing under Poudriere (https://gitlab.com/FreeBSD/freebsd-ports/-/commit/eb6c9c8c4aa5981078c6b9b69527ecdaee5f22c9)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
 	set(CMAKE_INSTALL_LIBEXECDIR      lib/${CMAKE_PROJECT_NAME})
 	set(CMAKE_INSTALL_FULL_LIBEXECDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR})
-endif(NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
+endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/bin/)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/lib/)
 set(CMAKE_DATA_OUTPUT_DIRECTORY    ${CMAKE_BINARY_DIR}/output/data/)
@@ -37,8 +39,8 @@
 	set(BITNESS "64")
 endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
 set(CMAKE_COLOR_DIAGNOSTICS ON)
-set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-deprecated-declarations -Wno-unused-result")
-set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} -Wpedantic -Wno-deprecated-declarations -Wno-unused-result")
+set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-unused-result")
+set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} -Wpedantic -Wno-unused-result -Wno-psabi")
 set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security -Wstrict-prototypes")
 set(CMAKE_CXX_FLAGS_DEBUG     "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
@@ -62,7 +64,11 @@
 option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
 option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
 option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
-option(WITH_BANDWIDTH     "Built-in Bandwidth"                                                ON)
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+	option(WITH_BANDWIDTH "Built-in Bandwidth"                                                ON) # Bandwidth is only supported on x86 CPUs (requires cache size)
+else()
+	set(WITH_BANDWIDTH OFF)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
 option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
 option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -37,9 +37,13 @@
 	)
 
 	# Install policy rule
+	pkg_get_variable(POLKIT_ACTION_DIR polkit-gobject-1 actiondir)
+	if(${POLKIT_ACTION_DIR} STREQUAL "")
+		set(POLKIT_ACTION_DIR "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/")
+	endif(${POLKIT_ACTION_DIR} STREQUAL "")
 	install(FILES
 		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy
-		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/
+		DESTINATION ${POLKIT_ACTION_DIR}
 	)
 
 	# Install schema file

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,12 +22,11 @@
 
 # NCurses
 if(WITH_NCURSES)
+	pkg_check_modules(NCURSES ncursesw)
 	# Assume ncurses from the base on FreeBSD
-	if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+	if(NOT NCURSES_FOUND AND ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
 		set(NCURSES_FOUND 1)
 		set(NCURSES_LIBRARIES "-l:libncursesw.so")
-	else()
-		pkg_check_modules(NCURSES ncursesw)
 	endif()
 	if(NCURSES_FOUND)
 		include_directories(${NCURSES_INCLUDE_DIRS})
@@ -47,28 +46,12 @@
 
 # Libcpuid
 if(WITH_LIBCPUID)
-	pkg_check_modules(LIBCPUID libcpuid>=0.6.0)
+	pkg_check_modules(LIBCPUID libcpuid>=0.7.0)
 	if(LIBCPUID_FOUND)
 		include_directories(${LIBCPUID_INCLUDE_DIRS})
 		link_directories(${LIBCPUID_LIBRARY_DIRS})
 		add_definitions(${LIBCPUID_CFLAGS_OTHER})
 		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
-		check_c_source_compiles(
-			"
-			#include <stdio.h>
-			#include <libcpuid/libcpuid.h>
-
-			int main()
-			{
-				printf(\"%i\", PURPOSE_LP_EFFICIENCY);
-				return 0;
-			}
-			"
-			HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY
-		)
-		if(HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
-			add_definitions(-DHAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
-		endif(HAS_LIBCPUID_PURPOSE_LP_EFFICIENCY)
 	endif(LIBCPUID_FOUND)
 endif(WITH_LIBCPUID)
 
@@ -156,18 +139,18 @@
 endif(WITH_DMIDECODE)
 
 # Bandwidth
-if(WITH_BANDWIDTH)
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
 	add_subdirectory(bandwidth)
 	if(BANDWIDTH_FOUND)
 		include_directories(bandwidth)
 		set(BANDWIDTH_LIBRARIES "bandwidth")
 	endif(BANDWIDTH_FOUND)
-endif(WITH_BANDWIDTH)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
 
 
 ### FINAL CONFIG
 
-message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration **${ColourReset}")
+message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration (${CMAKE_SYSTEM_PROCESSOR}) **${ColourReset}")
 
 # UI libraries
 print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
@@ -214,11 +197,16 @@
 	util.cpp
 	util.hpp
 )
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+	set(OTHER_LIBRARIES "-latomic")
+endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 
 add_executable(${DAEMON_EXEC}
 	daemon_server.cpp
 	daemon_server.hpp
 	daemon.h
+	data.cpp
+	data.hpp
 	logger.cpp
 	logger.hpp
 	options.cpp
@@ -260,12 +248,14 @@
 	-DHAS_LIBSYSTEM=${LIBSYSTEM}
 	-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}"
 	-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
+	-DCPUX_DATA_DIRECTORY="${CPU_X_DATA_DIRECTORY}"
 	-DTERMINFODIR="/lib/terminfo"
 	-DDAEMON_EXEC="${DAEMON_EXEC}"
 	-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
 	-DDAEMON_PATH="${DAEMON_PATH}"
 	-DSOCKET_NAME="${DAEMON_SOCKET}"
 )
+
 
 # Link libraries
 target_link_libraries(${APP_EXEC}
@@ -291,7 +281,6 @@
 )
 
 target_link_libraries(${DAEMON_EXEC}
-	${DAEMON_FLAGS}
 	${Intl_LIBRARIES}
 	${CMAKE_THREAD_LIBS_INIT}
 	std::filesystem

=== debian/changelog ===
cpu-x (5.1.1-0.1) unstable; urgency=medium

  * NMU
  * Recompile with libpci (>= 3.13) (closes: #1081187)
  * New upstream release (closes: #1089165)
  * Update: replace pkg-config with pkgconf.
  * Cherry-pick upstream patch to cmake STREQUAL issue
  * Use libcpuid (>= 0.7) per upstream changelog
  * Bike-shed-paint debian/watch uscan support file

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 10 Dec 2024 13:44:52 +0000

=== debian/control ===
--- 
+++ 
@@ -8,18 +8,18 @@
                cmake (>= 3),
                gawk,
                gettext,
-               libcpuid-dev (>= 0.6.4) [amd64 i386],
+               libcpuid-dev (>= 0.7) [amd64 i386],
                libgtkmm-3.0-dev (>= 3.12),
                libcurl4-gnutls-dev,
                libglfw3-dev,
                libjson-c-dev,
                libncurses-dev,
-               libpci-dev,
+               libpci-dev (>= 3.13),
                libproc2-dev,
                libstatgrab-dev,
                libvulkan-dev,
                nasm,
-               pkg-config,
+               pkgconf,
                procps,
 Standards-Version: 4.7.0
 Homepage: https://github.com/X0rg/CPU-X

## cpu-x 5.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	cmake_policy(SET CMP0177 NEW)
 endif()
 project(cpu-x
-	VERSION "5.1.1"
+	VERSION "5.1.3"
 	LANGUAGES C CXX
 )
 
@@ -70,6 +70,7 @@
 	set(WITH_BANDWIDTH OFF)
 endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
 option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
+option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
 option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)
 
 # Colours
@@ -127,9 +128,9 @@
 			ERROR_QUIET
 			OUTPUT_STRIP_TRAILING_WHITESPACE
 		)
-		if(NOT ${GIT_DESCRIBE_REVISION} STREQUAL "")
+		if(NOT GIT_DESCRIBE_REVISION STREQUAL "")
 			set(GIT_REVISION "+git-r${GIT_DESCRIBE_REVISION}")
-		endif(NOT ${GIT_DESCRIBE_REVISION} STREQUAL "")
+		endif(NOT GIT_DESCRIBE_REVISION STREQUAL "")
 	endif(GIT_FOUND)
 endif(EXISTS ${CMAKE_SOURCE_DIR}/.git)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -38,9 +38,9 @@
 
 	# Install policy rule
 	pkg_get_variable(POLKIT_ACTION_DIR polkit-gobject-1 actiondir)
-	if(${POLKIT_ACTION_DIR} STREQUAL "")
+	if(POLKIT_ACTION_DIR STREQUAL "")
 		set(POLKIT_ACTION_DIR "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/")
-	endif(${POLKIT_ACTION_DIR} STREQUAL "")
+	endif(POLKIT_ACTION_DIR STREQUAL "")
 	install(FILES
 		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy
 		DESTINATION ${POLKIT_ACTION_DIR}

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
 			"cpu-x-gtk-3.12.ui"
 		COMMAND	msgcat --indent --directory=${CMAKE_CURRENT_BINARY_DIR} source_c.pot source_ui.pot --output-file="${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
 		COMMAND sed --in-place "s/SOME DESCRIPTIVE TITLE./CPU-X translations template/" "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
-		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2024/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
+		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2025/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
 		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
 	)
 	GETTEXT_CONVERT_TRANSLATIONS(${pot_file} ALL ${po_files})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -229,6 +229,13 @@
 	add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
 endif()
 
+# AppImage workarounds
+if(APPIMAGE)
+	add_definitions(-DAPPIMAGE
+		-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
+	)
+endif(APPIMAGE)
+
 # Flatpak workarounds
 if(FLATPAK)
 	add_definitions(-DFLATPAK)
@@ -251,7 +258,6 @@
 	-DCPUX_DATA_DIRECTORY="${CPU_X_DATA_DIRECTORY}"
 	-DTERMINFODIR="/lib/terminfo"
 	-DDAEMON_EXEC="${DAEMON_EXEC}"
-	-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
 	-DDAEMON_PATH="${DAEMON_PATH}"
 	-DSOCKET_NAME="${DAEMON_SOCKET}"
 )

=== src/dmidecode/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(dmidecode
-	VERSION "3.6.20240424"
+	VERSION "3.6.20240903"
 	LANGUAGES C
 )

=== debian/changelog ===
cpu-x (5.1.3-0.1) unstable; urgency=medium

  * NMU
  * New upstream release
  * debian/control:
    + Bump Standards-Version to 4.7.2. No changes needed.
  * Forward port quilt patches

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 10 Mar 2025 14:45:22 +0000

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
                nasm,
                pkgconf,
                procps,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/X0rg/CPU-X
 Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
 Vcs-Browser: https://salsa.debian.org/debian/cpu-x
